#!/bin/sh

DRIVER=arcsas

echo "arcsas Driver post-Installation begining..."

MACHINE=`uname -m`
KERNEL=`uname -r`
export PATH=/bin:/sbin:/usr/bin:/usr/sbin

if echo ${KERNEL} | grep 'fc11\|el6'>/dev/null 2>/dev/null; then
INITRD=initrd
fi

mkdir /tmp/modules
(cd /tmp/modules; gzip -dc /tmp/arcsas/modules.cgz | cpio -idum) 1>/dev/null 2>&1 || { echo "Fail to extract drivers!"; exit 1; }

for ver in /lib/modules/*; do
	kver=`basename $ver`

	if [ -d /lib/modules/${kver} -a -d /tmp/modules/${kver} ]; then
		echo "Updating ${kver}..."
		mkdir /lib/modules/${kver}/extra/${DRIVER}
		mv /boot/${INITRD}-${kver}.img /boot/${INITRD}-${kver}.img.old && 
		cp /tmp/modules/${kver}/${MACHINE}/${DRIVER}.ko /lib/modules/${kver}/extra/${DRIVER}/ &&
		/sbin/depmod -a ${kver}

		if [ $? = 1 ]; then
			echo "Postinstall 1 failed! Please reinstall your Linux system."
			exit
		fi

		( grep -s -q scsi_wait_scan /lib/modules/${kver}/modules.dep ) && WITHWAIT="--with=scsi_wait_scan"
		if [ $INITRD = "initramfs" ]; then
			/usr/bin/dracut --add-drivers ${DRIVER} -f /boot/${INITRD}-${kver}.img ${kver}
                else
			/sbin/mkinitrd --with=${DRIVER} ${WITHWAIT} /boot/${INITRD}-${kver}.img ${kver}
		fi

		if [ $? = 1 ]; then
			echo "Postinstall 2 failed! Please reinstall your Linux system."
			exit
		fi
	fi
done

cd /
rm -fr /tmp/modules
rm -fr /tmp/arcsas

echo "arcsas Driver Installation Step 2 Completed."
